<?php

class ControllerModuleTeamMsnChat extends Controller {

    private $error = array();

    public function index() {
        $this->load->language('module/team_msn_chat');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            $this->model_setting_setting->editSetting('team_msn_chat', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->data['heading_title'] = $this->language->get('heading_title');

        $this->data['text_enabled'] = $this->language->get('text_enabled');
        $this->data['text_disabled'] = $this->language->get('text_disabled');
        $this->data['text_content_top'] = $this->language->get('text_content_top');
        $this->data['text_content_bottom'] = $this->language->get('text_content_bottom');
        $this->data['text_column_left'] = $this->language->get('text_column_left');
        $this->data['text_column_right'] = $this->language->get('text_column_right');
        $this->data['text_guide'] = $this->language->get('text_guide');
        $this->data['text_modules_tip'] = $this->language->get('text_modules_tip');
        $this->data['text_accounts_tip'] = $this->language->get('text_accounts_tip');
        $this->data['text_html_tip'] = $this->language->get('text_html_tip');

        $this->data['entry_layout'] = $this->language->get('entry_layout');
        $this->data['entry_position'] = $this->language->get('entry_position');

        $this->data['entry_name'] = $this->language->get('entry_account_name');
        $this->data['entry_html'] = $this->language->get('entry_account_html');

        $this->data['entry_status'] = $this->language->get('entry_status');
        $this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');
        $this->data['button_add_module'] = $this->language->get('button_add_module');
        $this->data['button_add_account'] = $this->language->get('button_add_account');
        $this->data['button_remove'] = $this->language->get('button_remove');

        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }

        $this->data['breadcrumbs'] = array();

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/team_msn_chat', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['action'] = $this->url->link('module/team_msn_chat', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

        if (isset($this->request->post['team_msn_chat_module'])) {
            
            $modules = explode(',', $this->request->post['team_msn_chat_module']);
            $this->data['modules'] =   $modules ;
            
        } elseif ($this->config->get('team_msn_chat_module') != '') {
            
            $modules = explode(',', $this->config->get('team_msn_chat_module'));
            $this->data['modules'] =  $modules ;
            
        } else {
            
            $modules = array();
            $this->data['modules'] = $modules;
        }


        foreach ($modules as $module) {

            if (isset($this->request->post['team_msn_chat_' . $module . '_layout_id'])) {
                $this->data['team_msn_chat_' . $module . '_layout_id'] = $this->request->post['team_msn_chat_' . $module . '_layout_id'];
            } else {
                $this->data['team_msn_chat_' . $module . '_layout_id'] = $this->config->get('team_msn_chat_' . $module . '_layout_id');
            }

            if (isset($this->request->post['team_msn_chat_' . $module . '_position'])) {
                $this->data['team_msn_chat_' . $module . '_position'] = $this->request->post['team_msn_chat_' . $module . '_position'];
            } else {
                $this->data['team_msn_chat_' . $module . '_position'] = $this->config->get('team_msn_chat_' . $module . '_position');
            }

            if (isset($this->request->post['team_msn_chat_' . $module . '_status'])) {
                $this->data['team_msn_chat_' . $module . '_status'] = $this->request->post['team_msn_chat_' . $module . '_status'];
            } else {
                $this->data['team_msn_chat_' . $module . '_status'] = $this->config->get('team_msn_chat_' . $module . '_status');
            }

            if (isset($this->request->post['team_msn_chat_' . $module . '_sort_order'])) {
                $this->data['team_msn_chat_' . $module . '_sort_order'] = $this->request->post['team_msn_chat_' . $module . '_sort_order'];
            } else {
                $this->data['team_msn_chat_' . $module . '_sort_order'] = $this->config->get('team_msn_chat_' . $module . '_sort_order');
            }
        }

        if (isset($this->request->post['team_msn_chat_accounts'])) {
            $accounts = explode(',', $this->request->post['team_msn_chat_accounts']);
            
            $this->data['accounts'] =   $accounts;
        
            
        } elseif ($this->config->get('team_msn_chat_accounts') != '') {
            
            $accounts = explode(',', $this->config->get('team_msn_chat_accounts'));
            
            $this->data['accounts'] =   $accounts;
            
        } else {
            
            $accounts = array();
            $this->data['accounts'] = $accounts;
        }


        foreach ($accounts as $account) {
            if (isset($this->request->post['team_msn_chat_accounts_' . $account . '_name'])) {
                $this->data['team_msn_chat_accounts_' . $account . '_name'] = $this->request->post['team_msn_chat_accounts_' . $account . '_name'];
            } else {
                $this->data['team_msn_chat_accounts_' . $account . '_name'] = $this->config->get('team_msn_chat_accounts_' . $account . '_name');
            }

            if (isset($this->request->post['team_msn_chat_accounts_' . $account . '_html'])) {
                $this->data['team_msn_chat_accounts_' . $account . '_html'] = $this->request->post['team_msn_chat_accounts_' . $account . '_html'];
            } else {
                $this->data['team_msn_chat_accounts_' . $account . '_html'] = $this->config->get('team_msn_chat_accounts_' . $account . '_html');
            }

            if (isset($this->request->post['team_msn_chat_accounts_' . $account . '_status'])) {
                $this->data['team_msn_chat_accounts_' . $account . '_status'] = $this->request->post['team_msn_chat_accounts_' . $account . '_status'];
            } else {
                $this->data['team_msn_chat_accounts_' . $account . '_status'] = $this->config->get('team_msn_chat_accounts_' . $account . '_status');
            }


        }

        $this->load->model('design/layout');

        $this->data['layouts'] = $this->model_design_layout->getLayouts();


        $this->template = 'module/team_msn_chat.tpl';
        $this->children = array(
            'common/header',
            'common/footer',
        );
 
        $this->response->setOutput($this->render());
    }

    private function validate() {
  

        if (!$this->user->hasPermission('modify', 'module/team_msn_chat')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        $i = 0;

        if (!empty($this->request->post)) {

            if ( $this->request->post['team_msn_chat_module'] == ''
                    &&
                 !$this->request->post['team_msn_chat_accounts']== ''
            ) {

                $this->error['warning'] = $this->language->get('error_module');
            }


            $accounts = explode(',', $this->request->post['team_msn_chat_accounts']);

            foreach ($accounts as $account) {
                
                $name = $this->request->post['team_msn_chat_accounts_'.$account.'_name'];
                $html = $this->request->post['team_msn_chat_accounts_'.$account.'_html'];
                
                 $html = str_replace('&amp;', '&',  $html);

                if (preg_match('/([a-zA-Z0-9]+?\@apps\.messenger\.live\.com)\&mkt\=[a-zA-Z]{1,8}?\-[a-zA-Z]{1,8}/m', $html, $regs)) {
                    $this->request->post['team_msn_chat_accounts_'.$account.'_html']= $regs[0];
                } else {

                    $this->data['team_msn_chat_accounts_'.$account.'_error_html'] = $this->language->get('error_html');
                    $this->error['warning'] = $this->language->get('error_html');
                }

                if (!$name) {

                     $this->data['team_msn_chat_accounts_'.$account.'_error_name'] = $this->language->get('error_name');
                     $this->error['warning'] = $this->language->get('error_name');
                }
            }
        }

        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

}

?>